# -----------------------------------------------------------------------------
# A couple of user-defined clips functions in Tcl
# -----------------------------------------------------------------------------
package require clips
clips::InitializeEnvironment
namespace import clips::*

# ------------------------------------------------------------
# The mul function on p.22 of the Advanced Programming Guide
# ------------------------------------------------------------

proc clips_mul {result} {
    if {[ArgCountCheck mul EXACTLY 2] == -1} {
	error "Wrong number of arguments"
	return;
    }
    set temp [CreateDataObject]
    if {[ArgTypeCheck mul 1 INTEGER_OR_FLOAT $temp] == 0} {
	DestroyDataObject $temp
	error "Expected an integer or float"
	return
    }
    if {[IsINTEGER $temp]} {
	set firstnumber [DOToLong $temp]
    } else {
	set firstnumber [DOToDouble $temp]
    }

    RtnUnknown 2 $temp
    if {[IsINTEGER $temp]} {
	set secondnumber [DOToLong $temp]
    } elseif {[IsFLOAT $temp]} {
	set secondnumber [DOToFloat $temp]
    } else {
	DestroyDataObject $temp
	error "Expected an integer or float"
	return
    }
    set r [expr {$firstnumber*$secondnumber}]
    SetType $result FLOAT
    SetValue $result [AddDouble $r]
    DestroyDataObject $temp
}

DefineFunction mul clips_mul

# Now go assert some facts using our mul function

AssertString "(three-times-four (mul 3 4))"
AssertString "(two-times-three (mul 2 3))"
Eval {(assert (five-times-two (mul 5 2)))}

# Print them out
Facts stdout
